% Created 2023-09-29 Fri 13:34
% Intended LaTeX compiler: pdflatex
\documentclass[presentation]{beamer}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{graphicx}
\usepackage{longtable}
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{capt-of}
\usepackage{hyperref}
\usetheme{Frankfurt}
\author{Jose Fernandes}
\date{2023-09-29}
\title{Robotics Operating System, version 2}
\hypersetup{
 pdfauthor={Jose Fernandes},
 pdftitle={Robotics Operating System, version 2},
 pdfkeywords={},
 pdfsubject={},
 pdfcreator={Emacs 28.2 (Org mode 9.7)}, 
 pdflang={English}}
\begin{document}

\maketitle
\begin{frame}{Outline}
\tableofcontents
\end{frame}



\section{ROS}
\label{sec:orga20219e}

\begin{frame}[label={sec:org6a4bb88}]{Personal Introduction}
\begin{exampleblock}{Profile}\label{sec:orgfc8f1b5}
\begin{itemize}
\item recent Meng Software Engineering, HWU;
\item junior software engineer at NR;
\item involved in some robotics projects/contracts.
\end{itemize}
\end{exampleblock}

\begin{block}{ROS experience}
\begin{itemize}
\item recently started the ROS journey (ROS2);
\item believes in its potential;
\item focusing on data/ml related problems;
\item contributing to ROS2.
\end{itemize}
\end{block}
\end{frame}


\begin{frame}[label={sec:org8786c0c}]{Robotics Operating System}
\begin{center}
\includegraphics[width=300px]{./ros-logo.png}
\end{center}

\begin{block}{Yet Another Operating System?}
and for robotics?!
\end{block}
\end{frame}



\begin{frame}[label={sec:orge2a4a0c}]{Industry before ROS}
\begin{columns}
\begin{column}{0.60\columnwidth}
\begin{block}{No safety or quality standards}
Industries demand standards!
\end{block}

\begin{block}{Difficult scalability}
\begin{itemize}
\item modularisation;
\item portability;
\item communication.
\end{itemize}
\end{block}

\begin{block}{Re-inventing the wheel problem}
\begin{itemize}
\item Roboticists are resourceful;
\item Multi-disciplinary engineers.
\end{itemize}
\end{block}
\end{column}


\begin{column}{0.40\columnwidth}
Unmaintainable systems!
\begin{center}
\includegraphics[width=.9\linewidth]{./spaghetti_system.jpeg}
\end{center}
\end{column}
\end{columns}
\end{frame}


\begin{frame}[label={sec:orge33c55e}]{ROS definition}
\begin{exampleblock}{Meta-OS for Robotic systems}\label{sec:org214fd32}
Full-featured Robotics Framework.
\end{exampleblock}


\begin{columns}
\begin{column}{0.60\columnwidth}
\begin{itemize}
\item Communication protocol layer;
\item System's runtime;
\item Package management.
\end{itemize}
\end{column}

\begin{column}{0.40\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./ros-robot.png}
\end{center}
\end{column}
\end{columns}
\end{frame}


\begin{frame}[label={sec:org92eef52}]{Why ROS was a great sucess?}
\begin{columns}
\begin{column}{0.50\columnwidth}
\begin{block}{great tooling}
\begin{itemize}
\item useful CLI;
\item 3D Simulations.
\end{itemize}
\end{block}

\begin{block}{great capabilities}
\begin{itemize}
\item extensive tooling;
\item navigation;
\item \ldots{}
\end{itemize}
\end{block}

\begin{block}{extensive ecosystem}
\begin{itemize}
\item ROS distributions;
\item ROS packages;
\item ROS plugins.
\end{itemize}
\end{block}
\end{column}


\begin{column}{0.50\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./unix_meme.jpeg}
\end{center}

``UNIX philosophy''

\begin{itemize}
\item simple interfaces;
\item loosely coupled;
\item highly composable.
\end{itemize}
\end{column}
\end{columns}
\end{frame}


\begin{frame}[label={sec:org3d2cd1d}]{Architecture of ROS version 1: Overview}
\begin{columns}
\begin{column}{0.60\columnwidth}
\begin{itemize}
\item Master node:
\begin{itemize}
\item environment's core;
\item listens for nodes' requests.
\end{itemize}
\item Nodes:
\begin{itemize}
\item software modules;
\end{itemize}
\item Communication:
\begin{itemize}
\item TCPROS/UDPROS;
\end{itemize}
\item SDKs:
\begin{itemize}
\item ROSPY/ROSCPP.
\end{itemize}
\end{itemize}
\end{column}

\begin{column}{0.40\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./ros1arch.png}
\end{center}
\end{column}
\end{columns}
\end{frame}


\begin{frame}[label={sec:org810cc61}]{Downsides of ROS1: Software Development Kits}
\begin{columns}
\begin{column}{0.50\columnwidth}
\begin{block}{ROSPY/ROSCPP}
\begin{itemize}
\item different development goals;
\item different capabilities.
\end{itemize}
\end{block}


\begin{alertblock}{Compatibility}
not consistent with each other.
\end{alertblock}
\end{column}

\begin{column}{0.50\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./ros1arch.png}
\end{center}
\end{column}
\end{columns}
\end{frame}


\begin{frame}[label={sec:orga119d6c}]{Downsides of ROS1: Question to audience}
\begin{center}
\includegraphics[width=200px]{./question.jpg}
\end{center}

\begin{alertblock}{What about ROS's topology?}
Is it optimal?
\end{alertblock}
\end{frame}


\begin{frame}[label={sec:org1e936d7}]{Downsides of ROS1: Centralised topology}
\begin{columns}
\begin{column}{0.50\columnwidth}
\begin{block}{Central node}
\begin{itemize}
\item Single point of failure!
\item Network congestion;
\item Process queueing.
\end{itemize}
\end{block}


\begin{alertblock}{Processing overhead}
Poor performance!
\end{alertblock}
\end{column}

\begin{column}{0.50\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./centralization.jpg}
\end{center}
\end{column}
\end{columns}
\end{frame}


\begin{frame}[label={sec:orgcd545e5}]{Downsides of ROS1: Networking}
\begin{columns}
\begin{column}{0.50\columnwidth}
\begin{block}{Custom networking protocol}
\begin{itemize}
\item node pub/sub management;
\item remote procedural call;
\item innefficient node discovery.
\end{itemize}
\end{block}


\begin{alertblock}{Middleware problem}
very difficult to scale.
\end{alertblock}
\end{column}

\begin{column}{0.50\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./ros1arch.png}
\end{center}
\end{column}
\end{columns}
\end{frame}




\section{V2 Architecture}
\label{sec:org8dc23d2}


\begin{frame}[label={sec:org669a85a}]{ROS2 Architecture}
\begin{center}
\includegraphics[width=300px]{./ros2-logo.png}
\end{center}

\begin{exampleblock}{Improvement!}\label{sec:org1934fca}
So lets explore how ROS2 improves things!
\end{exampleblock}
\end{frame}



\begin{frame}[label={sec:orgeb3d366}]{Architecture of ROS version 2: Overview}
\begin{columns}
\begin{column}{0.50\columnwidth}
\begin{itemize}
\item Nodes;

\item Communication:
\begin{itemize}
\item Data-Distribution Service.
\end{itemize}

\item Communication protocols:
\begin{itemize}
\item topics;
\item services;
\item actions.
\end{itemize}

\item SDK:
\begin{itemize}
\item RCL
\end{itemize}

\item Building:
\begin{itemize}
\item Ament;
\item Colcon.
\end{itemize}
\end{itemize}
\end{column}


\begin{column}{0.50\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./ros2arch.png}
\end{center}
\end{column}
\end{columns}
\end{frame}


\begin{frame}[label={sec:org8f263a1}]{Node}
\begin{columns}
\begin{column}{0.60\columnwidth}
\begin{block}{Node}
\begin{itemize}
\item software module;
\item performs a single task;
\item takes constructor arguments.
\end{itemize}
\end{block}

\begin{exampleblock}{Parametisation}\label{sec:org0318913}
\begin{itemize}
\item encourages node's reusability;
\item declarative paradigm.
\end{itemize}
\end{exampleblock}
\end{column}

\begin{column}{0.40\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./node.png}
\end{center}
\end{column}
\end{columns}
\end{frame}



\begin{frame}[label={sec:org3d2ad70}]{Topic}
Broadcast data streaming protocol.


\begin{columns}
\begin{column}{0.60\columnwidth}
\begin{block}{``Connectionless'' communication}
\begin{itemize}
\item publisher:
\begin{itemize}
\item send messages to topic.
\end{itemize}
\item subscriber:
\begin{itemize}
\item receive messages from topic.
\end{itemize}
\item publisher/subscriber:
\begin{itemize}
\item only ``connect'' to topic.
\end{itemize}
\end{itemize}
\end{block}

\begin{exampleblock}{Communication types}\label{sec:org9e84d42}
\begin{itemize}
\item one-to-one; one-to-many; many-to-many.
\end{itemize}
\end{exampleblock}
\end{column}

\begin{column}{0.40\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./topic.png}
\end{center}
\end{column}
\end{columns}
\end{frame}




\begin{frame}[label={sec:orgc088a0c}]{Service}
Request-based data exchange protocol;


\begin{columns}
\begin{column}{0.60\columnwidth}
\begin{block}{``Connectionful'' communication}
\begin{itemize}
\item each client will:
\begin{itemize}
\item request data from server.
\end{itemize}
\item client and server:
\begin{itemize}
\item nodes' internal component.
\end{itemize}
\item services are run asynchronously:
\begin{itemize}
\item non-blocking execution.
\end{itemize}
\end{itemize}
\end{block}

\begin{exampleblock}{Communication types}\label{sec:org9eb929f}
\begin{itemize}
\item one-to-one; one-to-many.
\end{itemize}
\end{exampleblock}
\end{column}

\begin{column}{0.40\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./service.png}
\end{center}
\end{column}
\end{columns}
\end{frame}




\begin{frame}[label={sec:orge123b1c}]{Action}
Communication protocol for goal-oriented tasks.

\begin{columns}
\begin{column}{0.50\columnwidth}
\begin{block}{Service and topic aggregation}
\begin{itemize}
\item action service:
\begin{itemize}
\item execution or cancelation requesting.
\end{itemize}
\item feedback topic:
\begin{itemize}
\item streams progress.
\end{itemize}
\item goal service:
\begin{itemize}
\item completion or failure reporting.
\end{itemize}
\end{itemize}
\end{block}
\end{column}

\begin{column}{0.50\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./action.png}
\end{center}
\end{column}
\end{columns}
\end{frame}



\begin{frame}[label={sec:org5d6c2d5}]{RCL Library}
\begin{columns}
\begin{column}{0.45\columnwidth}
\begin{itemize}
\item SDK in the C language;
\item implements API functionality;
\item serves minimal higher-level libraries.
\end{itemize}



\begin{exampleblock}{Trully language agnostic}\label{sec:orga016232}
Lets just sit back and enjoy.
\end{exampleblock}
\end{column}


\begin{column}{0.60\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./plmeme.png}
\end{center}
\end{column}
\end{columns}
\end{frame}


\section{DDS}
\label{sec:orgb49d378}

\begin{frame}[label={sec:org0d4f914}]{Distributed systems: Question to audience}
\begin{center}
\includegraphics[width=150px]{./distributed_systems.jpg}
\end{center}


\begin{exampleblock}{Distributed systems advantages?}\label{sec:org2024d4f}
Lets brainstorm for a bit.
\end{exampleblock}
\end{frame}


\begin{frame}[label={sec:org87ba83d}]{Data Distribution Service: Definition}
\begin{itemize}
\item published/subscriber communication open standard;
\item set of protocols for OSI/Hardware layers;
\item designed for real-time and embedded systems;
\item used in:
\begin{itemize}
\item transportation, infrastructure and military industries.
\end{itemize}
\end{itemize}

\begin{center}
\includegraphics[width=200px]{./dds_bus.png}
\end{center}
\end{frame}



\begin{frame}[label={sec:org7cd06d5}]{Data Distribution Service: Benefits}
\begin{block}{Data-driven}
\begin{itemize}
\item captures node's state through snapshots;
\item declarative interface.
\end{itemize}
\end{block}

\begin{block}{Transport independent}
\begin{itemize}
\item it is virtualised data bus;
\item routes data through network or shared memory.
\end{itemize}
\end{block}

\begin{block}{Great Quality of Service (QoS) policies}
\begin{itemize}
\item determines best QoS:
\begin{itemize}
\item when a node joins.
\end{itemize}
\item efficient node discoverability:
\begin{itemize}
\item initial broadcast signal.
\end{itemize}
\end{itemize}
\end{block}
\end{frame}

\begin{frame}[label={sec:org3ec521e}]{DDS and ROS2}
\begin{columns}
\begin{column}{0.55\columnwidth}
\begin{block}{ROS2 app = DDS app}
\begin{itemize}
\item backbone of ROS2;
\item interoptable any DDS app.
\end{itemize}
\end{block}


\begin{block}{Open Data Model}
\begin{itemize}
\item using standard data types;
\item ROS data language.
\end{itemize}
\end{block}


\begin{exampleblock}{Result}\label{sec:org7a8eec0}
peak performance and reliability!
\end{exampleblock}
\end{column}


\begin{column}{0.45\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./distributed_systems_2.jpg}
\end{center}
\end{column}
\end{columns}
\end{frame}



\section{ROS1 vs ROS2}
\label{sec:org73c4404}

\begin{frame}[label={sec:org5f1fd83}]{ROS 1 and 2: Question to the audience}
\begin{center}
\includegraphics[width=200px]{./wondering.jpg}
\end{center}


\begin{block}{Comparison ROS1 and ROS2}
What are the greatest advantages you see in ROS2?
\end{block}
\end{frame}


\begin{frame}[label={sec:org54a5a06}]{ROS 1 and 2: comprehensive comparison}
\begin{center}
\includegraphics[width=.9\linewidth]{./ros12_comparison.jpg}
\end{center}
\end{frame}

\begin{frame}[label={sec:org4fb9d41}]{Note: Migration and interoptability}
\begin{block}{Important notes}
\begin{enumerate}
\item ROS1 distributions are phasing out;
\item ROS2 distributions are already active, still maturing;
\item many applications are being upgraded:
\begin{itemize}
\item involves use of ROS bridges:
\end{itemize}
\end{enumerate}
\end{block}
\end{frame}


\section{Dev Environment}
\label{sec:org1a488a3}

\begin{frame}[label={sec:orgd164c0f}]{Development environment}
\begin{center}
\includegraphics[width=200px]{./ros_dev.png}
\end{center}


\begin{exampleblock}{Development}\label{sec:org96e2544}
so, lets talk about the development environment.
\end{exampleblock}
\end{frame}


\begin{frame}[label={sec:org2b930e1}]{Runnables}
\begin{block}{Executable}
\begin{itemize}
\item runs a ROS node program;
\item file executed from a package.
\end{itemize}
\end{block}

\begin{block}{Launch file}
\begin{itemize}
\item triggers single/multiple executables;
\item sets node parameters at runtime.
\end{itemize}
\end{block}
\end{frame}


\begin{frame}[label={sec:orgad6c490}]{Package}
\begin{block}{primary organization resource}
\begin{itemize}
\item every program must be packaged;
\item contains programs' meta-data.
\end{itemize}
\end{block}

\begin{block}{Main components}
\begin{center}
\begin{tabular}{ll}
package.xml: & - contains packages meta-information\\[0pt]
setup.py: & - explicit package install description\\[0pt]
setup.cfg: & - defines installed scripts location\\[0pt]
\end{tabular}
\end{center}
\end{block}
\end{frame}

\begin{frame}[label={sec:orgfe3c553}]{Workspace}
\begin{block}{Directory containing in-use packages}
\begin{itemize}
\item place to:
\begin{itemize}
\item develop packages;
\item execute commands.
\end{itemize}
\end{itemize}
\end{block}


\begin{block}{Main workspaces}
\begin{itemize}
\item system's workspace:
\begin{itemize}
\item runtime's packages.
\end{itemize}

\item local's workspace:
\begin{itemize}
\item own packages;
\item integrating packages.
\end{itemize}
\end{itemize}
\end{block}
\end{frame}



\begin{frame}[label={sec:org7748b95}]{Building tools}
\begin{block}{Ament}
\begin{itemize}
\item build system;
\item builds for many different languages;
\item uses XML file format.
\end{itemize}
\end{block}

\begin{block}{Colcon}
\begin{itemize}
\item command line building tool;
\item allows easy interface to build processes.
\end{itemize}
\end{block}
\end{frame}



\section{Getting Started}
\label{sec:org69b557c}

\begin{frame}[label={sec:org5f417c0}]{Intro: How do I get started?}
\begin{block}{Plan}
\begin{enumerate}
\item basic ``getting started'' guide;
\item Two brief practical demonstration:
\begin{enumerate}
\item docker development environment example;
\item Husarion Rosbot Gazebo Simulation.
\end{enumerate}
\end{enumerate}
\end{block}
\end{frame}


\begin{frame}[label={sec:orgeedd8e1},fragile]{Create package}
 \begin{verbatim}
# navigate to user's workspace
mkdir -p ~/ros2_ws/src && cd ~/ros2_ws/src

# bootstrapping
ros2 pkg create <package_name>              \
    --build-type ament_python               \
    --dependencies <package_dependencies>

# build the package
colcon build --packages-select my_package
\end{verbatim}
\end{frame}


\begin{frame}[label={sec:org762cfb0},fragile]{Write first program}
 \begin{verbatim}
import rclpy

class SimpleNode(rclpy.Node):
    def __init__(self):
        super().__init__("simple_node")
        print("Hello, World!")

def main(args=None):
    rclpy.init(args=args)
    simple_node = SimpleNode()
    simple_node.destroy_node()
    rclpy.shutdown()

if __name__ == "__main__": main()
\end{verbatim}
\end{frame}


\begin{frame}[label={sec:orgdc2fe97},fragile]{Launch file}
 \begin{verbatim}
from launch import LaunchDescription
from launch_ros.actions import Node

def generate_launch_description():
    return LaunchDescription([
        Node(
            package="my_package",
            executable="simple_node",
            output="screen"
        )
        # more nodes can be chained here
    ])
\end{verbatim}
\end{frame}


\begin{frame}[label={sec:org4c65387},fragile]{Execute first program}
 \begin{verbatim}
# sourcing environments
source /opt/ros/humble/setup.bash
source /home/simulations/ros2_ws/install/setup.bash

# run executable
ros2 run <package_name> <executable_file>

# OR laucher
ros2 launch <package_name> <launch_file>
\end{verbatim}
\end{frame}

\section{Demo}
\label{sec:orgb7bdfd4}

\begin{frame}[label={sec:org022fdb6}]{Demonstration}
\begin{center}
\includegraphics[width=.9\linewidth]{./demo.jpg}
\end{center}
\end{frame}

\begin{frame}[label={sec:org9277dbe}]{Considerations}
Still some incompatibility issues:

\begin{itemize}
\item Hardware;
\item Drivers (Nvidia);
\item Ubuntu versions;
\item ROS version;
\item ROS tooling.
\end{itemize}
\end{frame}



\begin{frame}[label={sec:org1e6fb27}]{Solution?}
\begin{columns}
\begin{column}{0.50\columnwidth}
\begin{itemize}
\item Docker:
\begin{itemize}
\item Docker compose.
\end{itemize}

\item Nvidia drivers:
\begin{itemize}
\item Nvidia runtime for docker.
\end{itemize}

\item X11:
\begin{itemize}
\item session forwarding;
\item dev environment only.
\end{itemize}
\end{itemize}
\end{column}


\begin{column}{0.50\columnwidth}
\begin{center}
\includegraphics[width=.9\linewidth]{./bob_ross.jpg}
\end{center}
\end{column}
\end{columns}
\end{frame}


\begin{frame}[label={sec:orge83ab28}]{Curious Fact - Nvidia closed source drivers}
\begin{center}
\includegraphics[width=.9\linewidth]{./nvidia_joker.jpeg}
\end{center}
\end{frame}


\begin{frame}[label={sec:org6d7d6a3}]{Resources}
\begin{itemize}
\item \href{https://husarion.com/tutorials/simulations/gazebo-rosbot-xl-slam-toolbox/}{Husarion tutorial - link}
\item \href{https://github.com/xecarlox94/.FILES/tree/master/scripts/.config/scripts/\_scripts}{My dotfiles - docker build/run scripts}
\end{itemize}
\end{frame}


\begin{frame}[label={sec:org4f0e6d7}]{Questions?}
Thank you for you attention!
\end{frame}
\end{document}